import java.util.*;

/** 
 * Skeleton code for doubly-connected edge list data structure
 */ 
 
class DCEL {
 
  ArrayList<Vertex> vertices = new ArrayList<Vertex>();
  ArrayList<HalfEdge> halfEdges = new ArrayList<HalfEdge>();
  ArrayList<Face> faces = new ArrayList<Face>();
  
  Face outerFace = null;
  
  public DCEL() {
    outerFace = this.new Face();
  }
  
  Vertex newVertex(Point2d coordinates) { return this.new Vertex(coordinates); }
  HalfEdge newHalfEdge(Vertex origin, Face face) { return this.new HalfEdge(origin, face); }
  Face newFace() { return this.new Face(); }
  
  ArrayList<HalfEdge> getCycleFrom(HalfEdge e) {
    // TODO Fill in
    return null; 
  }
  
  /**
   * Splits the face incident to e1 and e2 by adding an edge between the origins of e1 and e2. 
   * If e1 and e2 are not incident to the same face, or e1 is the next or prev of e2, nothing should
   * happen (because the call isn't "legal"). 
   */ 
  void splitFace(HalfEdge e1, HalfEdge e2) {
    
    // TODO
    
    // 0. Check whether the call is legal and return if not. 
    
    // 1. Create a new face for the second half of the split. 
    
    // 2. Create new half-edges for the splitting edge:
    
    // 3. Insert your new half-edges into the cyclic lists: 
    
    // 4. Make sure that all the half-edges point to the right face
    
    // 5. Make sure that each face correctly refers to an incident half-edge
    
  }
  
  class HalfEdge {
    HalfEdge twin = null, next = null, prev = null; 
    Vertex origin = null; 
    Face face = null;
    
    private HalfEdge(Vertex origin, Face face) {
      this.origin = origin;
      this.face = face;
      halfEdges.add(this);
      origin.outgoingEdge = this;
    }
    
    Vertex getDestination() {
      return twin.origin;
    }
    
    void splitInHalf() {
      
      // TODO
      
      // 1. Create a vertex for the mid-point
      
      // 2. Create the two new half-edges
      
      // 3. Set next/prev pointers
      
    }
  }
  
  class Vertex {
    Point2d coord;
    HalfEdge outgoingEdge; 
    private  Vertex(Point2d coordinates) {
      vertices.add(this);
      this.coord = coordinates; 
    }
  }
  
  class Face {
    HalfEdge incidentEdge; 
    private Face() {
      faces.add(this);
    }
  }
  
}